--------------------------
-- SinStats by Sinba-Pagle
--------------------------
local AddName, AddonTable = ...
local addVer = "TBC B4"

local labelSpellCrit = ""
local talentMod = 0
local arcaneMod = 0
local aiMod = 0
local labelHit = ""
local hitMod = 0
local DarkNessTalent = 0
local mp5 = 0
--mage
local arcaneMeditation = 0
local arcaneFocus = 0
local firepowerMod = 0
local apFire = 0
local pierceMod = 0
local apFrost = 0
local shadowMastery = 0
local magearmor = 0
-- paladin
local bowisdom = 0
local wisTalent = 0
-- shaman
local emberstorm = 0
local vengeance = 0
local spiritualHealing = 0
local springTotem = 0
local purification = 0
local natGuidance = 0
local elePrecision = 0
local unrStorm = 0
local natBlessing = 0
local eleMastery = 0
-- warlock
local felEnergy = 0 
local dsImp = 0
local dsSuc = 0
local dmfbuff = 0
local shadowFormDmg = 0
local silithyst = 0
local className, classFilename, classId = UnitClass("player") 
local playerLevel = UnitLevel("player")
local headerHeight = 15
local weaponTag = "Weapon"
local headerLoc = "Weapon Skills"
local defenseLoc = DEFENSE		
local spellSuccess = false
local regenBase = 0
local regenCasting = 0
local adjustedRegen = 0
local tempRegen = 0
local manaUsed = 0
local oldMana = 0
local ManaUpdate = false

if (GetLocale() == "frFR") then
	headerLoc = "Compétences d’armes"
	defenseLoc = DEFENSE
	weaponTag = "Arme"
elseif (GetLocale() == "esES") then
	weaponTag = "Arma"
	headerLoc = "Habilidades con armas"
	defenseLoc = DEFENSE	
elseif (GetLocale() == "deDE") then
	weaponTag = "Waffe"
	headerLoc = "Waffenfertigkeiten"
	defenseLoc = DEFENSE		
elseif (GetLocale() == "itIT") then
	weaponTag = "Arma"
	headerLoc = "Abilità con le armi"
	defenseLoc = DEFENSE		
elseif (GetLocale() == "ruRU") then
	weaponTag = "Oружие"
	headerLoc = "Оружейные навыки"
	defenseLoc = DEFENSE		
elseif (GetLocale() == "ptBR") then
	weaponTag = "Arma"
	headerLoc = "Weapon Skills"
	defenseLoc = DEFENSE	
elseif (GetLocale() == "zhCN") then
	headerLoc = "武器技能"
	defenseLoc = DEFENSE	
elseif (GetLocale() == "koKR") then
	headerLoc = "무기 기술"
	defenseLoc = "방어"	
elseif (GetLocale() == "zhTW") then
	headerLoc = "武器技能"
	defenseLoc = DEFENSE		
else 
	weaponTag = "Weapon"
	headerLoc = "Weapon Skills"
	defenseLoc = DEFENSE	
end

AddonTable.DisplayOrder = {
	{ hud="AP", init=true, grp=1, text="AP: ", textShort="AP: ", spell=29834, },
--	{ hud="APud", init=false, grp=1, text="AP UD: ", spell=17926, },	
	{ hud="RAP", init=false, grp=2, text="rAP: ", textShort="rAP: ", spell=34497, },
--	{ hud="RAPud", init=false, grp=2, text="rAP UD: ", spell=5502, },	
	{ hud="DMG", init=true, grp=1, text="DMG: ", textShort="DMG: ", spell=29801, },
	{ hud="RDMG", init=false, grp=2, text="rDMG: ", textShort="rDMG: ", spell=34482, },
	{ hud="Fire", init=false, grp=3, text="Fire: +", textShort="FIR: ", spell=34293, },	
	{ hud="Frost", init=false, grp=3, text="Frost: +", textShort="FRO: ", spell=31674, },	
	{ hud="Arcane", init=false, grp=3, text="Arcane: +", textShort="ARC: ", spell=31571, },
	{ hud="Shadow", init=false, grp=3, text="Shadow: +", textShort="SHA: ", spell=30293, },		
	{ hud="Nature", init=false, grp=3, text="Nature: +", textShort="NAT: ", spell=16578, },
	{ hud="Healing", init=false, grp=3, text="Healing: +", textShort="HEAL: ", spell=26022, },
	{ hud="Holy", init=false, grp=3, text="Holy: +", textShort="HOL: ", spell=31837, },		
--	{ hud="spellUD", init=false, grp=3, text="Undead: +", spell=17959, },		
	{ hud="Crit", init=true, grp=1, text="Crit: ", textShort="CRIT: ", spell=29859, }, 
	{ hud="CritCap", init=true, grp=1, text="Crit Cap: ", textShort="CAP: ", spell=32175, }, 	
	{ hud="RangedCrit", init=false, grp=2, text="rCrit: ", textShort="rCRIT: ", spell=34506, },
	{ hud="SpellCrit", init=false, grp=3, text="Spell Crit: ", textShort="sCRIT: ", spell=30288, },
	{ hud="Hit", init=true, grp=1, text="Hit: ", textShort="HIT: ", spell=31241, },
	{ hud="RangedHit", init=false, grp=2, text="rHit: ", textShort="rHIT: ", spell=34485, },
	{ hud="SpellHit", init=false, grp=3, text="Spell Hit: ", textShort="spHIT: ", spell=34935, },	
	{ hud="HasteMelee", init=true, grp=1, text="Haste: ", textShort="HAS: ", spell=31244, },
	{ hud="weaponSpeed", init=false, grp=1, text="AS: ", textShort="AS: ", spell=30664, },	
	{ hud="HasteRanged", init=false, grp=2, text="rHaste: ", textShort="rHAS: ", spell=23989, },	
	{ hud="rangedSpeed", init=false, grp=2, text="rAS: ", textShort="rAS: ", spell=34948, },		
	{ hud="HasteCaster", init=false, grp=3, text="Spell Haste: ", textShort="sHAS: ", spell=30060, },	
	{ hud="MeleeMiss", init=false, grp=1, text="Miss: " , textShort="MIS: ", spell=31858, },
	{ hud="MeleeBoss", init=false, grp=1, text="Miss+: ", textShort="MIS+: ", spell=1329, },
	{ hud="RangedMiss", init=false, grp=2, text="rMiss: ", textShort="rMIS: ", spell=34460, },
	{ hud="RangedBoss", init=false, grp=2, text="rMiss+: ", textShort="rMIS+: ", spell=34491, },
	{ hud="SpellMiss", init=false, grp=3, text="Spell Miss: ", textShort="sMIS: ", spell=30108, },
	{ hud="SpellBoss", init=false, grp=3, text="Spell Miss+: ", textShort="sMIS+: ", spell=30706, },	
	{ hud="ManaRegen", init=false, grp=3, text="Mana Regen: ", textShort="MP2: ", spell=31833, },
--	{ hud="CastingRegen", init=false, grp=3, text="Casting Regen: ", spell=34861, },
	{ hud="MP5Cast", init=false, grp=3, text="MP5: ", textShort="MP5: ", spell=19742, },
	{ hud="Armor", init=false, grp=1, text="Armor: ", textShort="ARM: ", spell=29140, },
	{ hud="DMGReduc", init=false, grp=1, text="Mitigation: ", textShort="MIT: ", spell=30356, },
	{ hud="Defense", init=false, grp=1, text="Defense: ", textShort="DEF: ", spell=32700, },
	{ hud="Dodge", init=false, grp=1, text="Dodge: ", textShort="DOD: ", spell=13981, },
	{ hud="Parry", init=false, grp=1, text="Parry: ", textShort="PAR: ", spell=3127, },
	{ hud="Block", init=false, grp=1, text="Block: ", textShort="BLO: ", spell=2565, },
	{ hud="FireResist", init=false, grp=4, text="Fire Res: ", textShort="FR: ", spell=18459, },
	{ hud="FrostResist", init=false, grp=4, text="Frost Res: ", textShort="FrR: ", spell=31667, },
	{ hud="ShadowResist", init=false, grp=4, text="Shadow Res: ", textShort="SR: ", spell=30283, },
    { hud="ArcaneResist", init=false, grp=4, text="Arcane Res: ", textShort="AR: ", spell=16850, },	
	{ hud="NatureResist", init=false, grp=4, text="Nature Res: ", textShort="NR: ", spell=30675, },  	
	{ hud="Speed", init=true, grp=5, text="Speed: ", textShort="SPE: ", spell=31641, },
	{ hud="Durability", init=true, grp=5, text="Durability: ", textShort="DUR: ", spell=3100, },
	{ hud="Lag", init=false, grp=5, text="Ping: ", textShort="LAG: ", spell=33592, },
	{ hud="FPS", init=false, grp=5, text="FPS: ", textShort="FPS: ", spell=19498, },
}

--------------------------------
-- Initialize Icons
--------------------------------
for i=1, #AddonTable.DisplayOrder do
	AddonTable.DisplayOrder[i].icon = "|T"..select(3, GetSpellInfo(AddonTable.DisplayOrder[i].spell))..":0|t"
end

--------------------------------
-- Event Update Function
--------------------------------
function AddonTable:RunAllEvents()
	SinStatsFrame:GetScript("OnEvent")(SinStatsFrame, "UPDATE_INVENTORY_DURABILITY")
	SinStatsFrame:GetScript("OnEvent")(SinStatsFrame, "UNIT_RESISTANCES")   
	SinStatsFrame:GetScript("OnEvent")(SinStatsFrame, "UNIT_ATTACK_POWER")
	SinStatsFrame:GetScript("OnEvent")(SinStatsFrame, "UNIT_RANGED_ATTACK_POWER")
	SinStatsFrame:GetScript("OnEvent")(SinStatsFrame, "UNIT_DAMAGE")  
	SinStatsFrame:GetScript("OnEvent")(SinStatsFrame, "UNIT_RANGEDDAMAGE")   
	SinStatsFrame:GetScript("OnEvent")(SinStatsFrame, "UNIT_DEFENSE")  
	SinStatsFrame:GetScript("OnEvent")(SinStatsFrame, "UNIT_STATS")       
	SinStatsFrame:GetScript("OnEvent")(SinStatsFrame, "UNIT_AURA") 
	SinStatsFrame:GetScript("OnEvent")(SinStatsFrame, "CHARACTER_POINTS_CHANGED")
end

--------------------------------
-- SavedVariable Initialisation
--------------------------------
local function initSinStatsDB()
	if not SinStatsDB then
		SinStatsDB = {
			SinLockVar = false,
			SinHideVar = false,
			StatDirection = false,
			IconVar = true,
			StatFontSize = 12,	
			SinMinimap = false,
			Stats = {},
		}
	end	
	for i=1, #AddonTable.DisplayOrder do
		if SinStatsDB.Stats[AddonTable.DisplayOrder[i].hud] == nil then
			SinStatsDB.Stats[AddonTable.DisplayOrder[i].hud] = AddonTable.DisplayOrder[i].init
		end
	end
	if not SinStatsDB.StatFontSize then
		SinStatsDB.StatFontSize = 12
	end
	if not SinStatsDB.minimap then
        SinStatsDB.minimap = {
            hide = false,
        }	
	end	
	
local DBObject = LibStub("LibDataBroker-1.1"):NewDataObject("SinStatsHUD", {
	type = "data source",
	text = "SinStats",
	icon = "Interface\\Icons\\Inv_weapon_shortblade_37",
	
	OnTooltipShow = function(tooltip)
		tooltip:SetText("|cff0489d1SinStats|r")
		tooltip:AddLine("Click to |cffFFF468Open/Close|r the settings", 1, 1, 1)
		tooltip:Show()
	end,
	
	OnClick = function(self, button, down) 
		AddonTable:ToggleConfig()
	end,
})
AddonTable.sshMiniButton = LibStub("LibDBIcon-1.0")		
AddonTable.sshMiniButton:Register("SinStatsHUD", DBObject, SinStatsDB.minimap)	
 end
	 

---------------------------
-- Local Helper Functions
---------------------------
local function spellCheck()
	if (classFilename == "DRUID") then
		local index = GetShapeshiftForm()
		if (index == 1) or (index == 3) then
			return true
		else
			return false
		end
	end
	if (classFilename == "MAGE") then
		for i = 1, 40 do
			local _, _, count, _, _, _, _, _, _, spellId = UnitBuff("player",i, "PLAYER", "HELPFUL")
			if not spellId then break end
			if spellId == 12042 then
			return true
		end
	end
		return false
	end
	if (classFilename == "PALADIN") or (classFilename == "PRIEST") then
	for i = 1, 40 do
		local _, _, _, _, _, _, _, _, _, spellId = UnitBuff("player",i, "HELPFUL")  
		if not spellId then break end   
		if spellId == 20218 then
			return true
		end
	end
		return false
	end 
end 

local function combustionSpell()
	if (classFilename == "MAGE") then
		for i = 1, 40 do
			local _, _, count, _, _, _, _, _, _, spellId = UnitBuff("player",i, "PLAYER", "HELPFUL")
			if not spellId then break end 
			if spellId == 28682 then
				count = count * 10
				return count
			end
		end
	end
end

local function shadowForm()
	if (classFilename == "PRIEST") then
		for i = 1, 40 do
			local _, _, _, _, _, _, _, _, _, spellId = UnitBuff("player",i, "HELPFUL")  
			if not spellId then break end   
			if spellId == 15473 then
				shadowFormDmg = 0.15
				 return shadowFormDmg
			end	
		end
	end
end

---------------------------
-- Stat update functions
---------------------------
local StatsFontSize = 12
local function SetFont(self)
	self:SetFont("Fonts/ARIALN.ttf", StatsFontSize, "OUTLINE")
end

local function CreateStatDisplay(parent, name, id)
	local f = parent:CreateFontString("$parent"..name, "OVERLAY", "GameFontNormal")
	f.ID = id
	SetFont(f)
	f:SetTextColor(1,1,1,1)
	parent.Stats[name] = f
	f:SetShown(SinStatsDB.Stats[name])
end

---------------------------
-- Creating the Stats Frame
---------------------------
local f = CreateFrame("frame", "SinStatsFrame", UIParent, BackdropTemplateMixin and "BackdropTemplate")
f:SetBackdrop({
    bgFile="Interface\\DialogFrame\\UI-DialogBox-Background",
    tile=1, tileSize=0, edgeSize=0,
})
f:SetBackdropColor(1,1,1,1)
f:SetWidth(200)
f:SetHeight(headerHeight)
f:SetPoint("CENTER",UIParent)
f:SetMovable(true)
f:SetUserPlaced(true)
f:SetClampedToScreen(false)
f:RegisterForDrag("LeftButton")
f:SetScript("OnDragStart", function(self) self:StartMoving() end)
f:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
f:SetFrameStrata("BACKGROUND")
f.DragText = f:CreateFontString(nil, "OVERLAY");
f.DragText:SetFontObject("GameFontHighlight");
f.DragText:SetTextColor(1, 1, 1)
f.DragText:SetText("SinStats")
f.DragText:SetPoint("CENTER")

f.Stats = {}
function f:ResizeStats()
	StatsFontSize = SinStatsDB.StatFontSize
	for k, v in pairs(self.Stats) do
		SetFont(v)
	end
end

local function AnchorStat(stat, horizontal, first, last)
	stat:ClearAllPoints()
	if not first then
		stat:SetPoint("TOPLEFT", 0, -headerHeight)
	else
		if horizontal then
			stat:SetPoint("LEFT", last, "RIGHT", 7, 0)	
		else
			stat:SetPoint("TOPLEFT", last, "BOTTOMLEFT")
		end				
	end
	return true, stat
end

local rowList = {}
function f:RedrawStats()
    local first, last
    local horizontal = SinStatsDB.SinDirection
    local rows = SinStatsDB.StatRows or 1
    table.wipe(rowList)
    if not SinStatsDB.GroupOrder then
        for i=1, #AddonTable.DisplayOrder do
            local k = AddonTable.DisplayOrder[i].hud
            local v = self.Stats[k]
            if v:IsShown() then
                if not horizontal or rows == 1 then
                    first, last = AnchorStat(v, horizontal, first, last)
                else        
                    tinsert(rowList, v)
                end
            end
        end
    else
        for i=1, #AddonTable.Groups do
            for n=1, #AddonTable.DisplayOrder do
                if AddonTable.DisplayOrder[n].grp == i then
                    local k = AddonTable.DisplayOrder[n].hud
                    local v = self.Stats[k]
                    if v:IsShown() then
                        if not horizontal or rows == 1 then
                            first, last = AnchorStat(v, horizontal, first, last)
                        else        
                            tinsert(rowList, v)
                        end
                    end
                end
            end
        end
    end
    if horizontal and rows > 1 then
        local totalRows = #rowList
        local maxOnRow = math.floor(totalRows / rows)
        local first, last
        for i=1, totalRows do
            if not first then
                AnchorStat(rowList[i], horizontal, first, last)
                first = rowList[i]
                last = first
            else
                rowList[i]:ClearAllPoints()
                if horizontal then 
                    rowList[i]:SetPoint("LEFT", last, "RIGHT", 7, 0)
                else
                    rowList[i]:SetPoint("TOPLEFT", last, "BOTTOMLEFT", 0, -3)
                end
--              AnchorStat(rowList[i], horizontal, first, last)
                last = rowList[i]
                horizontal = true
            end
            if mod(i, maxOnRow) == 0 then
                last = first
                first = rowList[i+1]
                horizontal = nil
            end
        end
    end
end

local updatespeed = 1.2
local TimeToNextUpdate = updatespeed

local function SetText(self, parent, text)
	local Icon = parent.AddIcons and AddonTable.DisplayOrder[self.ID].icon or ""
	if SinStatsDB.SinAbrev then
		self:SetText(Icon..AddonTable.DisplayOrder[self.ID].textShort..text) 
	else 
		self:SetText(Icon..AddonTable.DisplayOrder[self.ID].text..text)
	end
end

local function OnUpdate(self, elapsed)
	TimeToNextUpdate = TimeToNextUpdate - elapsed
	if TimeToNextUpdate > 0 then return end
	TimeToNextUpdate = updatespeed

	local _, stat, _, _ = UnitStat("player", 4);	

	
	-- Armor
	local base, effectiveArmor, armor, posBuff, negBuff = UnitArmor("player");
	SetText(self.Stats.Armor, self, effectiveArmor)

	-- Mitigation
	local base, effectiveArmor, armor, posBuff, negBuff = UnitArmor("player");
	local armorReduction = effectiveArmor/((85 * playerLevel) + 400);
	armorReduction = 100 * (armorReduction/(armorReduction + 1));
	SetText(self.Stats.DMGReduc, self, ("%.0f"):format(armorReduction) .. "%")        

	-- Melee Critical Strike
	local critChance = GetCritChance("player")
	SetText(self.Stats.Crit, self, ("%.2f"):format(critChance) .. "%")

	-- Spell Critical Strike
	local critSpellChance = GetSpellCritChance("player")
	if combustionSpell() then
		critSpellChance = critSpellChance + combustionSpell()
	end	
	-- if shamanSpells() then
		-- critSpellChance = critSpellChance + eleMastery
	-- end		
	--print(shamanSpells(eleMastery))
	SetText(self.Stats.SpellCrit, self, ("%.2f"):format(critSpellChance + arcaneMod + talentMod + eleMastery) .. "%" .. labelSpellCrit)

	-- Ranged Critical Strike
	local critRangedChance = GetRangedCritChance("player")
	SetText(self.Stats.RangedCrit, self, ("%.2f"):format(critRangedChance) .. "%")

	-- Melee Hit Chance
	local hitRating = GetCombatRatingBonus(CR_HIT_MELEE)
	if hitRating == nil then
		hitRating = 0
	end
	local hitChance = GetHitModifier("player")
	if hitChance == nil then
		hitChance = 0
	end
	SetText(self.Stats.Hit, self, ("%.2f"):format(hitChance + hitRating) .. "%")
	
	-- Attack Speed
	local mainSpeed, offSpeed = UnitAttackSpeed("player")
	if offSpeed == nil then
		offSpeed = ""
	else
		offSpeed = " / " .. ("%.1f"):format(offSpeed)
	end
	SetText(self.Stats.weaponSpeed, self, ("%.1f"):format(mainSpeed) .. offSpeed)
	
	-- Ranged Attack Speed	
	local speed = UnitRangedDamage("player");
	SetText(self.Stats.rangedSpeed, self,  ("%.1f"):format(speed));  

	-- Melee Miss Chance
	local meleeSameLevel = 0
	local meleeBossLevel = 0
	local mainBase, mainMod, offBase, offMod = UnitAttackBothHands("player")
	local levelDefense = playerLevel * 5
	local bossDefense = (playerLevel + 3) * 5
	local mWeaponSkill = (mainBase + mainMod)
	--local shieldEquipped = IsEquippedItemType("Shields")
	local mhID = GetInventoryItemID("player", 16);	
	local ohID = GetInventoryItemID("player", 17);
		
	local mWepSkill = mWeaponSkill
    if mWeaponSkill < 300 then 
		mWepSkill = 300 
    end				
	
	local meleeSkillDiff = levelDefense - mWeaponSkill
	local bossSkillDiff = bossDefense - mWeaponSkill
	local bossSkillMod = bossDefense - mWepSkill
	local missMod = 0
	local missModboss = 0	
	
	missModboss = meleeBossLevel
	
    if ohID then 
		_,_,_,_,_,itemType = GetItemInfo(ohID) 
    end    
	
    if mhID and (ohID and itemType == weaponTag) then
		if (classFilename == "WARRIOR") or (classFilename == "ROGUE") or (classFilename == "HUNTER") then
			--print("dual wield")
			if meleeSkillDiff > 10 then
				meleeSameLevel = (26 + ((meleeSkillDiff - 10) * 0.4))
				meleeSameLevel = meleeSameLevel - hitChance
			elseif meleeSkillDiff <= 10 then
				meleeSameLevel = (24 + ((meleeSkillDiff) * 0.1))
				meleeSameLevel = meleeSameLevel - hitChance		
			end
			
			if bossSkillDiff > 10 then
				meleeBossLevel = (26 + ((bossSkillDiff - 10) * 0.4))
				meleeBossLevel = meleeBossLevel - hitChance
				missMod = (26 + ((bossSkillMod - 10) * 0.4))
				missMod = missMod - hitChance
			elseif bossSkillDiff <= 10 then
				meleeBossLevel = (24 + ((bossSkillDiff) * 0.1))
				meleeBossLevel = meleeBossLevel - hitChance   	
				missMod = (26 + ((bossSkillMod - 10) * 0.4))
				missMod = missMod - hitChance				
			end
		end	
			
	elseif mhID and (ohID and itemType ~= weaponTag) then
	--print("shield or other offhand")
		if spellCheck() then
			meleeSameLevel = 5 - hitChance
			meleeBossLevel = 9 - hitChance
		else
			if meleeSkillDiff > 10 then
				meleeSameLevel = (7 + ((meleeSkillDiff - 10) * 0.4))
				meleeSameLevel = meleeSameLevel - hitChance
			elseif meleeSkillDiff <= 10 then
				meleeSameLevel = (5 + ((meleeSkillDiff) * 0.1))
				meleeSameLevel = meleeSameLevel - hitChance		
			end

			if bossSkillDiff > 10 then
				meleeBossLevel = (7 + ((bossSkillDiff - 10) * 0.4))
				meleeBossLevel = meleeBossLevel - hitChance  
				missMod = (7 + ((bossSkillMod - 10) * 0.4))
				missMod = missMod - hitChance					
			elseif bossSkillDiff <= 10 then
				meleeBossLevel = (5 + ((bossSkillDiff) * 0.1))
				meleeBossLevel = meleeBossLevel - hitChance   	
				missMod = (5 + ((bossSkillMod - 10) * 0.1))
				missMod = missMod - hitChance					
			end		
		end	
	
	elseif (not mhID and not ohID) then
	--print("fully unarmed")
		if spellCheck() then
			meleeSameLevel = 5 - hitChance
			meleeBossLevel = 9 - hitChance
		else
			if meleeSkillDiff > 10 then
				meleeSameLevel = (7 + ((meleeSkillDiff - 10) * 0.4))
				meleeSameLevel = meleeSameLevel - hitChance
			elseif meleeSkillDiff <= 10 then
				meleeSameLevel = (5 + ((meleeSkillDiff) * 0.1))
				meleeSameLevel = meleeSameLevel - hitChance		
			end

			if bossSkillDiff > 10 then
				meleeBossLevel = (7 + ((bossSkillDiff - 10) * 0.4))
				meleeBossLevel = meleeBossLevel - hitChance  
				missMod = (7 + ((bossSkillMod - 10) * 0.4))
				missMod = missMod - hitChance					
			elseif bossSkillDiff <= 10 then
				meleeBossLevel = (5 + ((bossSkillDiff) * 0.1))
				meleeBossLevel = meleeBossLevel - hitChance   
				missMod = (5 + ((bossSkillMod - 10) * 0.1))
				missMod = missMod - hitChance					
			end		
		end	
		
	elseif not mhID and (itemType == weaponTag) then
		--print("unarmed, weapon offhand")
		if (classFilename == "WARRIOR") or (classFilename == "ROGUE") or (classFilename == "HUNTER") then
			if meleeSkillDiff > 10 then
				meleeSameLevel = (26 + ((meleeSkillDiff - 10) * 0.4))
				meleeSameLevel = meleeSameLevel - hitChance
			elseif meleeSkillDiff <= 10 then
				meleeSameLevel = (24 + ((meleeSkillDiff) * 0.1))
				meleeSameLevel = meleeSameLevel - hitChance		
			end
			
			if bossSkillDiff > 10 then
				meleeBossLevel = (26 + ((bossSkillDiff - 10) * 0.4))
				meleeBossLevel = meleeBossLevel - hitChance
				missMod = (26 + ((bossSkillMod - 10) * 0.4))
				missMod = missMod - hitChance				
			elseif bossSkillDiff <= 10 then
				meleeBossLevel = (24 + ((bossSkillDiff) * 0.1))
				meleeBossLevel = meleeBossLevel - hitChance   	
				missMod = (26 + ((bossSkillMod - 10) * 0.4))
				missMod = missMod - hitChance					
			end
		end			

	elseif not mhID and (itemType ~= weaponTag) then
		--print("unarmed with shield or offhand")
		if spellCheck() then
			meleeSameLevel = 5 - hitChance
			meleeBossLevel = 9 - hitChance
		else
			if meleeSkillDiff > 10 then
				meleeSameLevel = (7 + ((meleeSkillDiff - 10) * 0.4))
				meleeSameLevel = meleeSameLevel - hitChance
			elseif meleeSkillDiff <= 10 then
				meleeSameLevel = (5 + ((meleeSkillDiff) * 0.1))
				meleeSameLevel = meleeSameLevel - hitChance		
			end

			if bossSkillDiff > 10 then
				meleeBossLevel = (7 + ((bossSkillDiff - 10) * 0.4))
				meleeBossLevel = meleeBossLevel - hitChance  
				missMod = (7 + ((bossSkillMod - 10) * 0.4))
				missMod = missMod - hitChance					
			elseif bossSkillDiff <= 10 then
				meleeBossLevel = (5 + ((bossSkillDiff) * 0.1))
				meleeBossLevel = meleeBossLevel - hitChance   	
				missMod = (5 + ((bossSkillMod - 10) * 0.1))
				missMod = missMod - hitChance					
			end		
		end	

	elseif mhID and not ohID then
		--print("1-handed weapon")
		if spellCheck() then
			meleeSameLevel = 5 - hitChance
			meleeBossLevel = 9 - hitChance
		else
			if meleeSkillDiff > 10 then
				meleeSameLevel = (7 + ((meleeSkillDiff - 10) * 0.4))
				meleeSameLevel = meleeSameLevel - hitChance
			elseif meleeSkillDiff <= 10 then
				meleeSameLevel = (5 + ((meleeSkillDiff) * 0.1))
				meleeSameLevel = meleeSameLevel - hitChance		
			end

			if bossSkillDiff > 10 then
				meleeBossLevel = (7 + ((bossSkillDiff - 10) * 0.4))
				meleeBossLevel = meleeBossLevel - hitChance  
				missMod = (7 + ((bossSkillMod - 10) * 0.4))
				missMod = missMod - hitChance				
			elseif bossSkillDiff <= 10 then
				meleeBossLevel = (5 + ((bossSkillDiff) * 0.1))
				meleeBossLevel = meleeBossLevel - hitChance  
				missMod = (5 + ((bossSkillMod - 10) * 0.1))
				missMod = missMod - hitChance					
			end		
		end			
	
	end
	
	if meleeSameLevel < 0 then
		meleeSameLevel = 0
	elseif meleeSameLevel > 100 then
		meleeSameLevel = 100
	end
	if meleeBossLevel < 0 then
		meleeBossLevel = 0
	elseif meleeBossLevel > 100 then
		meleeBossLevel = 100
	end
	SetText(self.Stats.MeleeMiss, self, ("%.1f"):format(meleeSameLevel) .. "%");
	SetText(self.Stats.MeleeBoss, self, ("%.1f"):format(meleeBossLevel) .. "%");
	
	
	-- Melee Critical Cap
	
    if ohID and itemType == weaponTag then 
		mWepSkill = math.min((mainBase + mainMod), (offBase + offMod)) 
		
    end	
	
	local skillDiff = 315 - mWepSkill
	local critSupp = 4.8	
	local dodgeBoss = 5 + (skillDiff * 0.1)
    local glancingBoss = 40	
	local extraWeaponSkill = mWepSkill - 300	
	local mcritCap = 100 - missMod - dodgeBoss - glancingBoss + critSupp + (extraWeaponSkill * 0.04)
	
	if critChance > mcritCap then
		critCapColor = "|cffC41E3A"
	elseif critChance == mcritCap then
		critCapColor = "|cffFF7C0A"
	else
		critCapColor = "|cff00f26d"
	end
	
	if mcritCap > 100 then
		mcritCap = 100
	end
	
	SetText(self.Stats.CritCap, self, critCapColor .. ("%.1f"):format(mcritCap) .. "%" .. "|r")	

	-- Ranged Hit Chance
	local hitRangedRating = GetCombatRatingBonus(CR_HIT_RANGED)
	if hitRangedRating == nil then
		hitRangedRating = 0
	end
	local hitRangedChance = GetHitModifier()
	if hitRangedChance == nil then
		hitRangedChance = 0
	end	
		SetText(self.Stats.RangedHit, self, ("%.2f"):format(hitRangedChance + hitRangedRating) .. "%"); 

	-- Ranged Miss Chance 
	local rangedMissLevel = 0
	local rangedMissBoss = 0
	local rangedAttackBase, rangedAttackMod = UnitRangedAttack("player")
	local levelDefense = playerLevel * 5
	local bossDefense = (playerLevel + 3) * 5
	local rWeaponSkill = (rangedAttackBase + rangedAttackMod)
	local rangedSkillDiff = levelDefense - rWeaponSkill
	local rbossSkillDiff = bossDefense - rWeaponSkill	
	
	
	if rangedSkillDiff > 10 then	
		rangedMissLevel = (7 + ((rangedSkillDiff - 10) * 0.4))
		rangedMissLevel = rangedMissLevel - hitRangedChance	
	elseif meleeSkillDiff <= 10 then	
		rangedMissLevel = (5 + ((rangedSkillDiff) * 0.1))
		rangedMissLevel = rangedMissLevel - hitRangedChance
	end
	
	if rbossSkillDiff > 10 then
		rangedMissBoss = (7 + ((rbossSkillDiff - 10) * 0.4))
		rangedMissBoss = rangedMissBoss - hitRangedChance	
	elseif rbossSkillDiff <= 10 then
		rangedMissBoss = (5 + ((rbossSkillDiff) * 0.1))
		rangedMissBoss = rangedMissBoss - hitRangedChance	
	end 
	
	if rangedMissLevel < 0 then
		rangedMissLevel = 0
	elseif rangedMissLevel > 100 then
		rangedMissLevel = 100
	end
	SetText(self.Stats.RangedMiss, self, ("%.1f"):format(rangedMissLevel) .. "%");	
	
	if rangedMissBoss < 0 then
		rangedMissBoss = 0
	elseif rangedMissBoss > 100 then
		rangedMissBoss = 100
	end
	SetText(self.Stats.RangedBoss, self, ("%.1f"):format(rangedMissBoss) .. "%|r");	
	
	-- Mana Regen

	--print(stat)
	-- oldMana = manaUsed
	-- print(oldMana, "oldMana")
	-- local manaUsed = UnitPower("player", Enum.PowerType.Mana)
	--print(manaUsedNew, "manaUsedNew")
	--print(manaUsed, "manaUsed")

--print(oldMana, "oldMana")
			--print(manaUsed, "ManaUsed")
		--print(oldMana, "oldMana")

	-- if spellSuccess then
	-- else

	--print("not true")
	regenBase, regenCasting = GetManaRegen()	
	regenBase = regenBase * 2
	regenCasting = (regenCasting * 2)
	
	adjustedRegen = regenBase - (mp5 * 0.4)
	
	tempRegen = (adjustedRegen * arcaneMeditation) + (adjustedRegen * magearmor)
	
	regenBase = regenBase + (stat * (unrStorm/100) * 0.4) + springTotem + bowisdom + felEnergy
	
	
--end


	--local adjustedRegen = regenBase - (mp5 * 0.4)
	--tempRegen = (adjustedRegen * arcaneMeditation) + (adjustedRegen * magearmor)
	--regenCasting = (regenCasting * 2)
	--print(regenCast, "Casting 2")
	-- local tempRegen = 0
	-- tempRegen = (0.001 + (162 * 0.01099 * 275^0.5)) * 5
	--print(tempRegen)
	--regenBase = regenBase + (stat * (unrStorm/100) * 0.4) + springTotem + bowisdom + felEnergy

	SetText(self.Stats.ManaRegen, self, ("%.2f"):format(regenBase))	
	--spellSuccess = false

	
	-- Spell Hit Chance
	local hitSpellRating = GetCombatRatingBonus(CR_HIT_SPELL)
	if hitSpellRating == nil then
		hitSpellRating = 0
	end
	local hitSpellChance = GetSpellHitModifier("player");
	if hitSpellChance == nil then
		hitSpellChance = 0
	end	
	hitSpellChance = hitSpellChance + hitMod + natGuidance + elePrecision + hitSpellRating
	SetText(self.Stats.SpellHit, self, ("%.2f"):format(hitSpellChance) .. "%" .. labelHit);  

	-- Spell Miss Chance
	local spellSameLevel = 3
	local spellBossLevel = 16
	spellSameLevel = (spellSameLevel - hitSpellChance)
	spellBossLevel = (spellBossLevel - hitSpellChance)
	if spellSameLevel < 0 then
		spellSameLevel = 0
	elseif spellSameLevel > 100 then
		spellSameLevel = 100
	end
	if spellBossLevel < 0 then
		spellBossLevel = 0
	elseif spellBossLevel > 100 then
		spellBossLevel = 100
	end
	SetText(self.Stats.SpellMiss, self, ("%.2f"):format(spellSameLevel) .. "%");
	SetText(self.Stats.SpellBoss, self, ("%.2f"):format(spellBossLevel) .. "%");

	-- Healing Spell Power
	local SinHealSpell = GetSpellBonusHealing();
	stat = stat * natBlessing
	SinHealSpell = (SinHealSpell + (SinHealSpell * spiritualHealing) + (SinHealSpell * purification) + stat)
	SetText(self.Stats.Healing, self, ("%.0f"):format(SinHealSpell));  

	-- Holy Spell Power
	local SinHolySpell = GetSpellBonusDamage(2);
	if spellCheck() then
		SinHolySpell = ((SinHolySpell * 0.1))
	end
	SetText(self.Stats.Holy, self, ("%.0f"):format(SinHolySpell)); 

	-- Nature Spell Power
	local SinNatureSpell = GetSpellBonusDamage(4);
	SinNatureSpell =  (SinNatureSpell + stat)
	SetText(self.Stats.Nature, self, SinNatureSpell); 

	-- Shadow Spell Power
	local SinShadowSpell = GetSpellBonusDamage(6);
	if (classFilename == "WARLOCK") then
			SinShadowSpell = (SinShadowSpell + (SinShadowSpell * dsSuc))
	end
	if shadowForm(shadowFormDmg) then
		SinShadowSpell = (SinShadowSpell + (SinShadowSpell * shadowFormDmg))
	end	
	SinShadowSpell = (SinShadowSpell + (SinShadowSpell * shadowMastery) + (SinShadowSpell * DarkNessTalent))
	SetText(self.Stats.Shadow, self, ("%.0f"):format(SinShadowSpell));        

	-- Fire Spell Power
	local SinFireSpell = GetSpellBonusDamage(3);    
	SinFireSpell = (SinFireSpell + (SinFireSpell * firepowerMod) + (SinFireSpell * aiMod) + (SinFireSpell * emberstorm) + stat) 
	if spellCheck() then
		SinFireSpell = (SinFireSpell + (SinFireSpell * 0.3))
	end 
	if (classFilename == "WARLOCK") then
			SinFireSpell = (SinFireSpell + (SinFireSpell * dsImp))
	end
	SetText(self.Stats.Fire, self, ("%.0f"):format(SinFireSpell));      

	-- Frost Spell Power
	local SinFrostSpell = GetSpellBonusDamage(5);               
	SinFrostSpell = (SinFrostSpell + (SinFrostSpell * pierceMod) + (SinFrostSpell * aiMod) + stat)     
	if spellCheck() then
		SinFrostSpell = (SinFrostSpell + (SinFrostSpell * 0.3))
	end       
	SetText(self.Stats.Frost, self, ("%.0f"):format(SinFrostSpell));   

	-- Arcane Spell Power
	local SinArcaneSpell = GetSpellBonusDamage(7);
	SinArcaneSpell = (SinArcaneSpell + (SinArcaneSpell * aiMod) + stat)
	if spellCheck() then
		SinArcaneSpell = (SinArcaneSpell + (SinArcaneSpell * 0.3))
	end
	SetText(self.Stats.Arcane, self, ("%.0f"):format(SinArcaneSpell));   
	
	-- Mana Regen Casting
	-- local regenBase, regenCast = GetManaRegen()	
	-- SetText(self.Stats.CastingRegen, self, (regenCast * 2))	

	-- Dodge
	local dodgeChance = GetDodgeChance("player");
	SetText(self.Stats.Dodge, self, ("%.2f"):format(dodgeChance) .. "%");       

	-- Parry
	local parryChance = GetParryChance("player");
	SetText(self.Stats.Parry, self, ("%.2f"):format(parryChance) .. "%"); 

	-- Block
	local blockChance = GetBlockChance("player");
	SetText(self.Stats.Block, self, ("%.2f"):format(blockChance) .. "%");    

	local currentSpeed, runSpeed, flightSpeed, swimSpeed = GetUnitSpeed("player")
	SetText(self.Stats.Speed, self, string.format("%d%%", ("%.2f"):format(GetUnitSpeed("player") / 7 * 100)));

	local framerate = GetFramerate()
	if framerate < 30 then
		SetText(self.Stats.FPS, self, "|cffC41E3A" .. floor(framerate) .. "|r")
	elseif framerate > 30 and framerate < 50 then
		SetText(self.Stats.FPS, self, "|cffFF7C0A" .. floor(framerate) .. "|r")
	elseif framerate > 50 then
		SetText(self.Stats.FPS, self, "|cff00f26d" .. floor(framerate) .. "|r")
	end

	local _, _, _, lagWorld = GetNetStats();
	if lagWorld < 90 then
		SetText(self.Stats.Lag, self, "|cff00f26d" .. lagWorld .. " ms|r"); 
	elseif lagWorld >= 90 and lagWorld < 200 then
		SetText(self.Stats.Lag, self, "|cffFF7C0A" .. lagWorld .. " ms|r"); 
	elseif lagWorld > 200 then
		SetText(self.Stats.Lag, self, "|cffC41E3A" .. lagWorld .. " ms|r"); 
	end	
	
	
end

local function talentScan()
	local className, classFilename, classId = UnitClass("player")
	if (classFilename == "MAGE") then   
	local _, _, _, _, points, _, _, _ = GetTalentInfo(2, 14)
	    if points > 0 then
		talentMod = (points * 2)
	    end
	local _, _, _, _, points, _, _, _ = GetTalentInfo(1, 17)
	    if points > 0 then
		arcaneMod = points * 1
		aiMod = ((points * 1)/100)
	    end
	local _, _, _, _, points, _, _, _ = GetTalentInfo(1, 12) 
		arcaneMeditation = ((points * 10)/100)	
	local _, _, _, _, points, _, _, _ = GetTalentInfo(3, 3)
	    if points > 0 then
		hitMod = points
	    end
	-- local _, _, _, _, points, _, _, _ = GetTalentInfo(1, 2)
	    -- if points > 0 then
		-- arcaneFocus = points * 2
		-- labelHit = (" (|cff69CCF0+" .. ("%.0f"):format(arcaneFocus) .. "|r)")   
	    -- end     
	local _, _, _, _, points, _, _, _ = GetTalentInfo(2, 17)      
	    if points > 0 then
		firepowerMod = ((points * 2)/100)
	    end     
	local _, _, _, _, points, _, _, _ = GetTalentInfo(3, 8)
	    if points > 0 then
		pierceMod = ((points * 2) / 100)
	    end 

	elseif (classFilename == "PRIEST") then
	local _, _, _, _, points, _, _, _ = GetTalentInfo(2, 3)
	    if points > 0 then
		talentMod = points * 1
		labelSpellCrit = (" (|cffedede6+" .. ("%.0f"):format(talentMod) .. "|r)")
	    end	
	local _, _, _, _, points, _, _, _ = GetTalentInfo(3, 5)
	    if points > 0 then
		hitMod = points * 2
		--labelHit = (" (|cff8787ED+" .. ("%.0f"):format(hitMod) .. "|r)")    
	    end  
	local _, _, _, _, points, _, _, _ = GetTalentInfo(3, 17)
	    if points > 0 then
		DarkNessTalent = ((points * 2) / 100)
	    end     		
	local _, _, _, _, points, _, _, _ = GetTalentInfo(2, 16)   
	    if points > 0 then
		spiritualHealing = ((points * 2) / 100)
	    end     

	elseif (classFilename == "PALADIN") then
	local _, _, _, _, points, _, _, _ = GetTalentInfo(1, 10)
	    if points > 0 then
		wisTalent = ((points * 10)/100)
	    end 

	elseif (classFilename == "WARLOCK") then
	local _, _, _, _, points, _, _, _ = GetTalentInfo(1, 16)
	    if points > 0 then
		shadowMastery = ((points * 2)/100)
	    end         
	local _, _, _, _, points, _, _, _ = GetTalentInfo(3, 16)
	    if points > 0 then
		emberstorm = ((points * 2)/100)
	    end     

	elseif (classFilename == "SHAMAN") then
	local _, _, _, _, points, _, _, _ = GetTalentInfo(3, 15)  
	    if points > 0 then
			purification = ((points * 2)/100)
	    end     
	local _, _, _, _, points, _, _, _ = GetTalentInfo(3, 6)  
	    if points > 0 then
			natGuidance = (points)
	    end  
	local _, _, _, _, points, _, _, _ = GetTalentInfo(1, 15)  
	    if points > 0 then
			elePrecision = (points * 2)
	    end  
	local _, _, _, _, points, _, _, _ = GetTalentInfo(1, 14)  
	    if points > 0 then
			unrStorm = (points * 2)
	    end  		
	end 
	local _, _, _, _, points, _, _, _ = GetTalentInfo(3, 18)  
	    if points > 0 then
			natBlessing = ((points * 10) / 100)
	    end  		
	end 	
 
f:SetScript("OnEvent", function (self, event, ...)
	local spirit, effectiveSpirit, posBuffSpirit, negBuffSpirit = UnitStat("player", 5)
	if event == "PLAYER_LOGIN" then
		print("|cff0489d1SinStats v" .. addVer .. " loaded|r. Type |cff00c0ff/sinstats|r or |cff00c0ff/ss|r to open the settings.")
		initSinStatsDB()
		self.AddIcons = SinStatsDB.IconVar
		talentScan()
		StatsFontSize = SinStatsDB.StatFontSize
		for i=1, #AddonTable.DisplayOrder do
			local Settings = AddonTable.DisplayOrder[i]
			if SinStatsDB and SinStatsDB.Stats[Settings.hud] == nil then
				print("|cffff0000SinsStats:|r Missing Saved Variable:|cff00ff00", Settings.hud)
			else
				CreateStatDisplay(self, Settings.hud, i)
			end
		end
		self:ResizeStats()
		self:RedrawStats()
		
		
		
		StaticPopupDialogs["SINSTATS_HUD_RESET"] = {
			text = "Reset the HUD's position ?",
			button1 = "Yes",
			button2 = "No",
			timeout = 0,
			whileDead = true,
			hideOnEscape = false,		
			OnAccept = function(self) 
				SinStatsFrame:SetUserPlaced(false)
				SinStatsFrame:ClearAllPoints()
				SinStatsFrame:SetPoint("CENTER", 0, 0)
				SinStatsFrame:SetUserPlaced(true)
			end,
			OnCancel = function(self) end, 
		}
		self:RegisterEvent("UNIT_STATS", "player")
		self:RegisterUnitEvent("UNIT_AURA", "player")
--		self:RegisterEvent("PLAYER_EQUIPMENT_CHANGED")
		self:RegisterEvent("CHARACTER_POINTS_CHANGED")
		self:RegisterEvent("BIND_ENCHANT")
		self:RegisterEvent("REPLACE_ENCHANT")
--		self:RegisterEvent("UPDATE_SHAPESHIFT_FORM")
		self:RegisterEvent("UPDATE_INVENTORY_DURABILITY")
		self:RegisterUnitEvent("UNIT_RESISTANCES", "player")
		self:RegisterEvent("UNIT_DAMAGE")
		self:RegisterEvent("UNIT_RANGEDDAMAGE")
		self:RegisterEvent("UNIT_ATTACK_POWER")
		self:RegisterEvent("UNIT_RANGED_ATTACK_POWER")
		self:RegisterEvent("UNIT_DEFENSE")
		self:RegisterEvent("PLAYER_LEVEL_UP")
		--self:RegisterUnitEvent("UNIT_SPELLCAST_SUCCEEDED", "player")
		--self:RegisterUnitEvent("UNIT_POWER_UPDATE", "player")

		AddonTable:RunAllEvents()
		AddonTable:UpdateStatus()
		self:SetScript("OnUpdate", OnUpdate)
		
	-- elseif event == "UNIT_SPELLCAST_SUCCEEDED" then
	
		-- ManaUpdate = true

		-- if ManaUpdate then
			-- C_Timer.After(5.0, function() spellSuccess = true end)
		-- else
			-- spellSuccess = false
		-- end		
		
	-- elseif event == "UNIT_POWER_UPDATE" then
	
		-- manaUsed = oldMana
		-- oldMana = UnitPower("player", Enum.PowerType.Mana)

		-- if oldMana ~= ManaUsed then
			-- ManaUpdate = true
			-- print("Mana Updated")
		-- else
			-- ManaUpdate = false
			-- print("Mana NOT Updated")
		-- end

		
	elseif event == "UNIT_DEFENSE" then
	
		local baseDefense = 0
		local bonusDefense = 0
		local DefGearIndex = 0		
		local DefGear = GetNumSkillLines()
		local DefHeader = nil
		
		for i = 1, DefGear do
			local DefName = select(1, GetSkillLineInfo(i))
			local headerCheck = select(2, GetSkillLineInfo(i))
			
			if headerCheck ~= nil and headerCheck then
				DefHeader = DefName;
			else
				if (DefHeader == headerLoc) and (DefName == defenseLoc) then
					DefGearIndex = i
					break
				end
			end	
		end
		
		if (DefGearIndex > 0) then
			baseDefense = select(4, GetSkillLineInfo(DefGearIndex))
			bonusDefense = select(6, GetSkillLineInfo(DefGearIndex))
		end
		
		local defenseRating = GetCombatRatingBonus(CR_DEFENSE_SKILL)
		
		SetText(self.Stats.Defense, self, format("%.0f", (baseDefense + bonusDefense + defenseRating)))   
		
	elseif event == "UNIT_RESISTANCES" then
	    local base, bonus, total = UnitResistance("player",2)
		local effectiveFR = bonus
		SetText(self.Stats.FireResist, self, effectiveFR)

		local base, bonus, total = UnitResistance("player",5)
		local effectiveSR = bonus
		SetText(self.Stats.ShadowResist, self, effectiveSR)

		local base, bonus, total = UnitResistance("player",4)
		local effectiveFrR = bonus
		SetText(self.Stats.FrostResist, self, effectiveFrR)
		
        local base, bonus, total = UnitResistance("player",6)
        local effectiveAR = bonus
        SetText(self.Stats.ArcaneResist, self, effectiveAR)  		

		local base, bonus, total = UnitResistance("player",3)
		local effectiveNR = bonus
		SetText(self.Stats.NatureResist, self, effectiveNR)   

	elseif event == "UPDATE_INVENTORY_DURABILITY" then
		local Durability, Current, Full, Percent
		local LowestCurrent, LowestFull, t1, t2, t3 = 500, 0, 0, 0, 100
		for i=1,19 do
			Current, Full = GetInventoryItemDurability(i)
			if Current and Full then
				Percent = floor(100*Current/Full + 0.5)
				if (Percent < t3) then
					t3 = Percent
				end
				if (Current < LowestCurrent) then
					LowestCurrent = Current
					LowestFull = Full
				end
				t1 = t1 + Current
				t2 = t2 + Full
			end
		end
		if t2 == 0 then
			Durability = "N/A"
		else
			Durability = floor(t1 * 100 / t2)
		end
		local Text = ""
		if type(Durability) == "number" then
			if Durability > 50 then
				Text = string.format("|cff%2xff00", ((Durability > 50) and (255 - 2.55*Durability) or (2.55*Durability)), Durability) .. Text
			else
				Text = string.format("|cffff%2x00", (2.55*Durability), Durability) .. Text
			end
			Text = Text..Durability.."%"
		end
		SetText(self.Stats.Durability, self, Text)         

	elseif event == "UNIT_ATTACK_POWER" then
		local base, posBuff, negBuff = UnitAttackPower("player");
		local effectiveAP = base + posBuff + negBuff;
		SetText(self.Stats.AP, self, effectiveAP); 

	elseif event == "UNIT_RANGED_ATTACK_POWER" then
		local base, posBuff, negBuff = UnitRangedAttackPower("player");
		local effectiveRanged = base + posBuff + negBuff;
		SetText(self.Stats.RAP, self, effectiveRanged);

	elseif event == "UNIT_DAMAGE" then
		local lowDmg, hiDmg, offlowDmg, offhiDmg, posBuff, negBuff, percentmod = UnitDamage("player");
		local dmgeffect = hiDmg;		
		SetText(self.Stats.DMG, self, ("%.0f"):format(dmgeffect));

	elseif event == "UNIT_RANGEDDAMAGE" then
		local speed, lowDmg, hiDmg, posBuff, negBuff, percent = UnitRangedDamage("player");
		local Rdmgeffect = hiDmg;
		SetText(self.Stats.RDMG, self,  ("%.0f"):format(Rdmgeffect));    

	elseif event == "CHARACTER_POINTS_CHANGED" then
		talentScan()
		self:RedrawStats()

	elseif event == "PLAYER_LEVEL_UP" then
		playerLevel = UnitLevel("player")

	else -- Other Events
		local base = 0
		local _, Intellect, _, _ = UnitStat("player", 4)
		local _, Spirit, _, _ = UnitStat("player", 5)
		
		if (classFilename ~= "WARRIOR") and (classFilename ~= "ROGUE") then
			if playerLevel == 60 then
				base = (0.001 + (Spirit * 0.01099 * Intellect^0.5)) * 5
			end
		end
	

		mp5 = 0
		local tierPieces = 0
		local zgPieces = 0 
		local pouchCounter = 0
		local atkspeed = 0	
		if (classFilename ~= "WARRIOR") and (classFilename ~= "ROGUE") then
			for i=1,23 do
				local itemLink = GetInventoryItemLink("player", i)
				if itemLink then
					local stats = GetItemStats(itemLink)
					if stats then
						local statMP5 = stats["ITEM_MOD_POWER_REGEN0_SHORT"]
						if (statMP5) then
							mp5 = mp5 + statMP5 + 1
						end
					end
					if (classFilename == "PRIEST") or (classFilename == "DRUID") or (classFilename == "PALADIN") or (classFilename == "SHAMAN") then
						local itemName = C_Item.GetItemNameByID(GetInventoryItemLink("player", i))
						if itemName then
							if classId == 5 then 
								if string.sub(itemName, -13) == "Transcendence" then
									tierPieces = tierPieces + 1
								end
							elseif classId == 11 then 
								if string.sub(itemName, 1, 9) == "Stormrage" then
									tierPieces = tierPieces + 1
								end
								if (string.sub(itemName, 10, 17) == "Haruspex") or 
									(string.sub(itemName, -15) == "South Seas Kelp") or
									(string.sub(itemName, 1, 9) == "Wushoolay") then
	                    							zgPieces = zgPieces + 1
								end
							elseif classId == 2 then 
								if (string.sub(itemName, 10, 20) == "Freethinker") or 
									(string.sub(itemName, 1, 7) == "Gri'lek") or
									(string.sub(itemName, 1, 12) == "Hero's Brand") then
										zgPieces = zgPieces + 1
								end
							elseif classId == 7 then 
								if (string.sub(itemName, 1, 5) == "Augur") or 
									(string.sub(itemName, 1, 8) == "Unmarred") or
									(string.sub(itemName, 1, 9) == "Wushoolay") then
										zgPieces = zgPieces + 1
									end
							end
						end
					end
					if (classFilename == "HUNTER") then
						local itemName = C_Item.GetItemNameByID(GetInventoryItemLink("player", i))
						if itemName then
							if (string.sub(itemName, -10) == "Ammo Pouch") or
								(string.sub(itemName, 1, 10) == "Small Shot") or
								(string.sub(itemName, -9) == "Ammo Sack") or
								(string.sub(itemName, -6) == "Quiver") then
									pouchCounter = 10
							elseif (string.sub(itemName, 1, 9) == "Bandolier") or
								(string.sub(itemName, -11) == "Night Watch") then
									pouchCounter = 11
							elseif (string.sub(itemName, 1, 3) == "Heavy Leather") or
								(string.sub(itemName, 1, 12) == "Heavy Quiver") then
									pouchCounter = 12
							elseif (string.sub(itemName, 1, 13) == "Thick Leather") or
								(string.sub(itemName, 1, 9) == "Quickdraw") then
									pouchCounter = 13
							elseif (string.sub(itemName, 1, 8) == "Ribbly's") then
								pouchCounter = 14
							elseif (string.sub(itemName, 1, 10) == "Gnoll Skin") or 
								(string.sub(itemName, 1, 10) == "Harpy Hide") or
								(string.sub(itemName, -6) == "Lamina") then
									pouchCounter = 15								
							end		        
						end				
					end										
				end
			end
		end 

		local effectiveMR = mp5 * 0.4       
		local talentRegen = 0
		local totemTalent = 0
		if (classFilename == "MAGE") then
			local _, _, _, _, points, _, _, _ = GetTalentInfo(1, 12) 
			talentRegen = (((base)/100) * (points * 5))
		elseif (classFilename == "DRUID") then
			local _, _, _, _, points, _, _, _ = GetTalentInfo(3, 6) 
			talentRegen = ((base/100) * (points * 5))
		elseif (classFilename == "PRIEST") then
			local _, _, _, _, points, _, _, _ = GetTalentInfo(1, 8) 
			talentRegen = ((base/100) * (points * 5))
		elseif (classFilename == "SHAMAN") then
			local _, _, _, _, points, _, _, _ = GetTalentInfo(3, 10)
			totemTalent = ((base/100) * (points * 5))
		end 

		magearmor = 0
		local evoc = 0  
		felEnergy = 0 
		local siphonregen = 0
		local siphoncast = 0    
		local innerregen = 0
		local innercast = 0
		bowisdom = 0
		local wismp5 = 0
		local springtotem = 0
		springTotem = 0	
		dsSuc = 0
		dsImp = 0
		local tidetotem = 0
		local swregen = 0   
		local fishsoup = 0
		local fishsoupmp5 = 0   
		local sageFish = 0
		local warchief = 0
		local mageblood = 0
		local meleeHaste = 100	
		local rangedHaste = 100
		local castHaste = 100
		local epiphany = 0
		-- local wickerman = 0
		if (classFilename ~= "WARRIOR") and (classFilename ~= "ROGUE") then 
			for i = 1, 40 do
				local _, _, _, _, _, _, _, _, _, spellId = UnitBuff("player",i, "HELPFUL")
				if not spellId then break end   
				if spellId == 29166 then 
					innerregen = ((base)*4)
					innercast = base    
			    	end
				if spellId == 16609 then 
					warchief = 10
				end 
				if spellId == 25941 then
					sageFish = 6
				end
				
				-- blessing wisdom
				if spellId == 19742 then 
					bowisdom = (((10 * wisTalent) * 0.4) + (10 * 0.4))
					wismp5 = ((10 * wisTalent)  + 10)
				elseif spellId == 19850 then 
					bowisdom = (((15 * wisTalent) * 0.4) + (15 * 0.4))
					wismp5 = ((15 * wisTalent)  + 15)   
				elseif spellId == 19852 then
					bowisdom = (((20 * wisTalent) * 0.4) + (20 * 0.4))
					wismp5 = ((20 * wisTalent)  + 20)   
				elseif spellId == 19853 then
					bowisdom = (((25 * wisTalent) * 0.4) + (25 * 0.4))
					wismp5 = ((25 * wisTalent)  + 25)   
				elseif spellId == 19854 then 
					bowisdom = (((30 * wisTalent) * 0.4) + (30 * 0.4))
					wismp5 = ((30 * wisTalent)  + 30)   
				elseif spellId == 25290 then 
					bowisdom = (((33 * wisTalent) * 0.4) + (33 * 0.4))
					wismp5 = ((33 * wisTalent)  + 33)   
				elseif spellId == 25894 then 
					bowisdom = (((30 * wisTalent) * 0.4) + (30 * 0.4))
					wismp5 = ((30 * wisTalent)  + 30)   
				elseif spellId == 25918 then
					bowisdom = (((33 * wisTalent) * 0.4) + (33 * 0.4))
					wismp5 = ((33 * wisTalent)  + 33)	 
				end
				
				-- totems
				if spellId == 5677 then 
					if totemTalent > 0 then
						springtotem = 6 + totemTalent
					else
						springtotem = 6
						springTotem = 6
					end 
				elseif spellId == 10491 then 
					if totemTalent > 0 then
						springtotem = 9 + totemTalent
					else
						springtotem = 9
						springTotem = 9
					end 
				elseif spellId == 10493 then 
					if totemTalent > 0 then
						springtotem = 13 + totemTalent
					else
						springtotem = 13
						springTotem = 13
					end 
				elseif spellId == 10494 then 
					if totemTalent > 0 then
						springtotem = 17 + totemTalent
						springTotem = 17 + totemTalent
					else
						springtotem = 17
						springTotem = 17
					end 
				elseif spellId == 24853 then   
					springtotem = 27
				elseif spellId == 16191 then 
					tidetotem = 114 
				elseif spellId == 17355 then 
					tidetotem = 154 
				-- else
					-- springtotem = 0
					-- springTotem = 0
				end
				
				-- consumes
				if spellId == 18194 then 
					fishsoup = (8 * 0.4)
					fishsoupmp5 = 8 
				end
				if spellId == 15604 then 
					swregen = 60
				end 
				if spellId == 24363 then
					mageblood = 12
				end
				-- if spellId == 24705 then
				-- wickerman = ((base)*0.25)
			-- end
				if (classFilename == "MAGE") then  
				
					if spellId == 6117 or spellId == 22782 or spellId == 22783 then 
						magearmor = 0.3
					elseif spellId == 12051 then
						evoc = ((base)*15)
					end	
					if spellId == 23723 then
						castHaste = (castHaste + 33)
					end
					if spellId == 21165 then
						meleeHaste = (meleeHaste + 20)
					end
					if spellId == 26635 then
						local health = UnitHealth("player")
						local max_health = UnitHealthMax("player")
						local percenthealth = ((health/max_health) * 100)
						if percenthealth > 40 then	
							rangedHaste = (rangedHaste + 10)
							meleeHaste = (meleeHaste + 10)
							castHaste = (castHaste + 10)
						else 
							rangedHaste = (rangedHaste + 30)
							meleeHaste = (meleeHaste + 30)
							castHaste = (castHaste + 30)
						end
					end			
				end
				if (classFilename == "WARLOCK") then
					local maxpower = UnitPowerMax("player" , mana);
					if spellId == 18792 then 
						felEnergy = ((maxpower * 0.03) / 2)
					end
					if spellId == 18371 then 
						siphonregen = ((base)*2)
						siphoncast = ((base)/2)     
					end    
					if spellId == 16322 then 
						meleeHaste = (meleeHaste + 3)
					end			
					if spellId == 7396 then 
						meleeHaste = (meleeHaste + 10)
					end
					if spellId == 16609 then
						meleeHaste = (meleeHaste + 15)
					end
					if spellId == 15167 then
						meleeHaste = (meleeHaste + 65)
					end
					if spellId == 21165 then 
						meleeHaste = (meleeHaste + 20)
					end			
					if spellId == 18791 then
						dsSuc = 0.15
					elseif spellId == 18789 then
						dsImp = 0.15
					end					
				end 
				if (classFilename == "DRUID") then
					if spellCheck() then
						if spellId == 16322 then
							meleeHaste = (meleeHaste + 3)
						end			
						if spellId == 7396 then
							meleeHaste = (meleeHaste + 10)
						end
						if spellId == 16609 then
							meleeHaste = (meleeHaste + 15)
						end		
						if spellId == 15167 then 
							meleeHaste = (meleeHaste + 65)
						end		
				if spellId == 28866 then 
					meleeHaste = (meleeHaste + 20)
				end								
						if spellId == 13494 then 
							meleeHaste = (meleeHaste + 50)
						end
					end
				end
				if (classFilename == "HUNTER") then
					if spellId == 16322 then 
						meleeHaste = (meleeHaste + 3)
					end			
					if spellId == 7396 then 
						meleeHaste = (meleeHaste + 10)
					end		
					if spellId == 16609 then 
						meleeHaste = (meleeHaste + 15)
					end		
					if spellId == 15167 then 
						meleeHaste = (meleeHaste + 65)
					end			
					if spellId == 3045 then 
						rangedHaste = (rangedHaste + 40)
					end		
				if spellId == 28866 then 
					meleeHaste = (meleeHaste + 20)
				end							
					if spellId == 6150 then 
						rangedHaste = (rangedHaste + 30)
					end	
					if spellId == 26635 then
						local health = UnitHealth("player")
						local max_health = UnitHealthMax("player")
						local percenthealth = ((health/max_health) * 100)
						if percenthealth > 40 then	
							rangedHaste = (rangedHaste + 10)
							meleeHaste = (meleeHaste + 10)
							castHaste = (castHaste + 10)
						else
							rangedHaste = (rangedHaste + 30)
							meleeHaste = (meleeHaste + 30)		
							castHaste = (castHaste + 30)			
						end
					end	
				end
				if (classFilename == "PALADIN") then
					if spellId == 16322 then 
						meleeHaste = (meleeHaste + 3)
					end			
					if spellId == 7396 then 
						meleeHaste = (meleeHaste + 10)
					end		
					if spellId == 16609 then 
						meleeHaste = (meleeHaste + 15)
					end		
				if spellId == 28866 then 
					meleeHaste = (meleeHaste + 20)
				end							
					if spellId == 15167 then 
						meleeHaste = (meleeHaste + 65)
					end		
					if spellId == 21165 then 
						meleeHaste = (meleeHaste + 20)
					end			
					if spellId == 23733 then 
						meleeHaste = (meleeHaste + 25)
						castHaste = (castHaste + 33)
					end		
				end
				if (classFilename == "PRIEST") then
					if spellId == 28804 then
						epiphany = 24 
					end
					if spellId == 16322 then 
						meleeHaste = (meleeHaste + 3)
					end			
					if spellId == 7396 then 
						meleeHaste = (meleeHaste + 10)
					end		
					if spellId == 16609 then 
						meleeHaste = (meleeHaste + 15)
					end		
					if spellId == 15167 then 
						meleeHaste = (meleeHaste + 65)
					end			
					if spellId == 21165 then 
						meleeHaste = (meleeHaste + 20)
					end		
					if spellId == 26635 then
						local health = UnitHealth("player")
						local max_health = UnitHealthMax("player")
						local percenthealth = ((health/max_health) * 100)
						if percenthealth > 40 then	
								rangedHaste = (rangedHaste + 10)
								meleeHaste = (meleeHaste + 10)
								castHaste = (castHaste + 10)
						else 
								rangedHaste = (rangedHaste + 30)
								meleeHaste = (meleeHaste + 30)		
								castHaste = (castHaste + 30)			
						end
					end	
				end	
				if (classFilename == "SHAMAN") then
					if spellId == 16322 then 
						meleeHaste = (meleeHaste + 3)
					end			
					if spellId == 7396 then 
						meleeHaste = (meleeHaste + 10)
					end	
				if spellId == 28866 then 
					meleeHaste = (meleeHaste + 20)
				end			
				if spellId == 16166 then
					eleMastery = 100
				else
					eleMastery = 0	
				end				
					if spellId == 16609 then 
						meleeHaste = (meleeHaste + 15)
					end		
					if spellId == 15167 then 
						meleeHaste = (meleeHaste + 65)
					end		
					if spellId == 21165 then 
						meleeHaste = (meleeHaste + 20)
					end			
					if spellId == 26635 then
						local health = UnitHealth("player")
						local max_health = UnitHealthMax("player")
						local percenthealth = ((health/max_health) * 100)
						if percenthealth > 40 then	
							rangedHaste = (rangedHaste + 10)
							meleeHaste = (meleeHaste + 10)
							castHaste = (castHaste + 10)
						else 
							rangedHaste = (rangedHaste + 30)
							meleeHaste = (meleeHaste + 30)		
							castHaste = (castHaste + 30)			
						end
					end	
				end	
			end
		end

		if (classFilename == "WARRIOR") then
			for i = 1, 40 do
				local _, _, _, _, _, _, _, _, _, spellId = UnitBuff("player",i, "HELPFUL")
				if not spellId then break end   
				if spellId == 12966 then 
					meleeHaste = (meleeHaste + 5)
				elseif spellId == 12967 then 
					meleeHaste = (meleeHaste + 10)
				elseif spellId == 12968 then 
					meleeHaste = (meleeHaste + 15)
				elseif spellId == 12969 then 
					meleeHaste = (meleeHaste + 20)	
				elseif spellId == 12970 then 
					meleeHaste = (meleeHaste + 25)
				end
				if spellId == 28866 then 
					meleeHaste = (meleeHaste + 20)
				end		
				if spellId == 16322 then 
					meleeHaste = (meleeHaste + 3)
				end			
				if spellId == 7396 then 
					meleeHaste = (meleeHaste + 10)
				end		
				if spellId == 16609 then
					meleeHaste = (meleeHaste + 15)
				end		
				if spellId == 15167 then 
					meleeHaste = (meleeHaste + 65)
				end		
				if spellId == 21165 then 
					meleeHaste = (meleeHaste + 20)
				end		
				if spellId == 26635 then 
					local health = UnitHealth("player")
					local max_health = UnitHealthMax("player")
					local percenthealth = ((health/max_health) * 100)
					if percenthealth > 40 then	
						rangedHaste = (rangedHaste + 10)
						meleeHaste = (meleeHaste + 10)
						castHaste = (castHaste + 10)		
					else 
						rangedHaste = (rangedHaste + 30)
						meleeHaste = (meleeHaste + 30)	
						castHaste = (castHaste + 30)		
					end
				end	
			end
		
		elseif (classFilename == "ROGUE") then
		for i = 1, 40 do
			local _, _, _, _, _, _, _, _, _, spellId = UnitBuff("player",i, "HELPFUL")
			if not spellId then break end   
				if spellId == 5171 then 
					meleeHaste = (meleeHaste + 20)
				elseif spellId == 6774 then 
					meleeHaste = (meleeHaste + 30)
				end
				if spellId == 28866 then 
					meleeHaste = (meleeHaste + 20)
				end						
				if spellId == 13877 then 
					meleeHaste = (meleeHaste + 20)
				end
				if spellId == 16322 then 
					meleeHaste = (meleeHaste + 3)
				end		
				if spellId == 7396 then 
					meleeHaste = (meleeHaste + 10)
				end			
				if spellId == 16609 then 
					meleeHaste = (meleeHaste + 15)
				end	
				if spellId == 15167 then 
					meleeHaste = (meleeHaste + 65)
				end	
				if spellId == 21165 then 
					meleeHaste = (meleeHaste + 20)
				end		
				if spellId == 26635 then
					local health = UnitHealth("player")
					local max_health = UnitHealthMax("player")
					local percenthealth = ((health/max_health) * 100)
					if percenthealth > 40 then	
						rangedHaste = (rangedHaste + 10)
						meleeHaste = (meleeHaste + 10)
						castHaste = (castHaste + 10)		
					else 
						rangedHaste = (rangedHaste + 30)
						meleeHaste = (meleeHaste + 30)	
						castHaste = (castHaste + 30)		
					end
				end	
			end
		end

		local hasteHead = 0
		local hasteLegs = 0
		local hasteHands = 0
		local slotId = GetInventorySlotInfo("HandsSlot")
		local link = GetInventoryItemLink("player", slotId)
		-- print("link", link)
		if link then
			local itemId, enchantId = link:match("item:(%d+):(%d+)")
			if enchantId then
				enchantId = tonumber(enchantId)
				-- print("enchantId", enchantId, enchantId == 931)
				if enchantId == 931 then
					hasteHands = hasteHands + 1
				end
			end
		end
		local slotId = GetInventorySlotInfo("HeadSlot")
		local link = GetInventoryItemLink("player", slotId)
		if link then
			local itemId, enchantId = link:match("item:(%d+):(%d+)")
			if enchantId then
				enchantId = tonumber(enchantId)
				if enchantId == 2543 then
					hasteHands = hasteHands + 1
				end
			end
		end	
		local slotId = GetInventorySlotInfo("LegsSlot")
		local link = GetInventoryItemLink("player", slotId)
		if link then
			local itemId, enchantId = link:match("item:(%d+):(%d+)")
			if enchantId then
				enchantId = tonumber(enchantId)
				if enchantId == 2543 then
					hasteHands = hasteHands + 1
				end
			end
		end		
		SetText(self.Stats.HasteMelee, self, meleeHaste + hasteHands .. "%")  
		SetText(self.Stats.HasteRanged, self, rangedHaste + pouchCounter + hasteHands .. "%") 
		SetText(self.Stats.HasteCaster, self, castHaste .. "%")  
	
		local oilEnchants = 0
		local oilRegen = 0
		if (classFilename ~= "WARRIOR") and (classFilename ~= "ROGUE") and (classFilename ~= "HUNTER") then
			local hasMainHandEnchant, _, _, mainHandEnchantID, _, _, _, _ = GetWeaponEnchantInfo()
			if hasMainHandEnchant then
				if mainHandEnchantID == 2624 then
					oilEnchants = 4
					oilRegen = oilEnchants * 0.4
				elseif mainHandEnchantID == 2625 then
					oilEnchants = 8
					oilRegen = oilEnchants * 0.4
				elseif mainHandEnchantID == 2629 then
					oilEnchants = 12
					oilRegen = oilEnchants * 0.4
				end
			end
		end 

		local tierBonus = 0
		if tierPieces >= 3 then
			tierBonus = ((base) * 0.15)
		end
		local zgMP5 = 0 	
		if zgPieces >= 2 then
			zgMP5 = 4
		end         
		
		
 		--SetText(self.Stats.ManaRegen, self, format("%.0f", (base) + effectiveMR + innerregen + evoc + bowisdom + fishsoup + springtotem + tidetotem + siphonregen + swregen + felEnergy + oilRegen + (warchief * 0.4) + (mageblood * 0.4) + (zgMP5 * 0.4) + (epiphany * 0.4) + (sageFish * 0.4)))
		--SetText(self.Stats.CastingRegen, self, format("%.0f", effectiveMR + innercast + magearmor + talentRegen + bowisdom + fishsoup + springtotem + tidetotem + siphoncast + tierBonus + swregen + felEnergy + (warchief * 0.4) + (mageblood * 0.4) + oilRegen + (zgMP5 * 0.4) + (epiphany * 0.4) + (sageFish * 0.4)))   
		SetText(self.Stats.MP5Cast, self, format("%.0f", (mp5) + wismp5 + fishsoupmp5 + zgMP5 + oilEnchants + warchief + mageblood + epiphany + sageFish)) 
	end        
end)
f:RegisterEvent("PLAYER_LOGIN")


-------------------------------------------
-- Slash command to open the Settings frame
-------------------------------------------
SLASH_SINSTATS1 = "/sinstats"
SLASH_SS1 = "/ss"
function SlashCmdList.SINSTATS()
	AddonTable:ToggleConfig()
end
function SlashCmdList.SS()
	AddonTable:ToggleConfig()
end